Subject: bug#15126: 24.3; kmacro-end-and-call-macro repeats macro multiple times following isearch-forward

From: Juri Linkov <[email-masked]>
Date: Tue, 20 Aug 2013 02:50:56 +0300

> In Emacs 24.2.1 and all previous versions I've used,
> kmacro-end-and-call-macro calls the macro once more, and I can go
> through the file making changes one at a time, and I can stop when I
> want.
>
> In Emacs 24.3.1, kmacro-end-and-call-macro calls the macro repeatedly
> making changes to all the repeated text up to the end of the file.

I can't find a change that caused this regression.
At least, I see that it is not caused by the fix for bug#4894
that added `store-kbd-macro-event' to `isearch-other-meta-char'.
But removing `store-kbd-macro-event' from `isearch-unread'
that is called from `isearch-other-meta-char' fixes this bug.
Perhaps this is a wrong fix and I don't know how to fix this properly.
`isearch-other-meta-char' currently is full of crap that should be
rewritten and reduced to a more manageable size.